//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%37FDFEB188E0.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%37FDFEB188E0.cm

//## begin module%37FDFEB188E0.cp preserve=no
//## end module%37FDFEB188E0.cp

//## Module: DummyResponse%37FDFEB188E0; Package specification
//## Subsystem: XSModel::Data::Detector%367691B76668
//	/local/data/verisB/dorman/Xspec/src/detector
//## Source file: /data/verisB/dorman/Xspec/src/XSModel/Data/Detector/DummyResponse.h

#ifndef DUMMYRESPONSE_H
#define DUMMYRESPONSE_H 1

//## begin module%37FDFEB188E0.additionalIncludes preserve=no
//## end module%37FDFEB188E0.additionalIncludes

//## begin module%37FDFEB188E0.includes preserve=yes
//## end module%37FDFEB188E0.includes

// Response
#include <XSModel/Data/Detector/Response.h>
// UserDummyResponse
#include <XSModel/Data/Detector/UserDummyResponse.h>
//## begin module%37FDFEB188E0.declarations preserve=no
//## end module%37FDFEB188E0.declarations

//## begin module%37FDFEB188E0.additionalDeclarations preserve=yes
//## end module%37FDFEB188E0.additionalDeclarations


//## begin DummyResponse%3641DA6E0109.preface preserve=yes
//## end DummyResponse%3641DA6E0109.preface

//## Class: DummyResponse%3641DA6E0109
//## Category: XSModel::Data::Detector%36349D570394
//## Subsystem: XSModel::Data::Detector%367691B76668
//## Persistence: Transient
//## Cardinality/Multiplicity: n



//## Uses: <unnamed>%3DF61B8901DC;SumComponent { -> }

class DummyResponse : public UserDummyResponse  //## Inherits: <unnamed>%3E567C600043
{
  //## begin DummyResponse%3641DA6E0109.initialDeclarations preserve=yes
  //## end DummyResponse%3641DA6E0109.initialDeclarations

  public:
    //## Destructor (generated)
      ~DummyResponse();


    //## Other Operations (specified)
      //## Operation: Instance%37FB7D2EC2C0; C++
      static DummyResponse* Instance (Real eMin = 0.5, 	// Default value 0.5 keV for lower end of energy range in
      	// Dummy response. All defaults are user redefinable.
      Real eMax = 20., 	// Default upper energy range
      size_t nE = 40, bool ln = false);

      //## Operation: resetEnergies%37FD1085B6D8; C++
      void resetEnergies (Real eMin, Real eMax, size_t nE = 10, bool ln = false);

      //## Operation: operator*%37FE0B5509B8; C++
      //	Additional Public Declarations
      virtual Model& operator * (Model& model) const;

      //## Operation: operator*%3DE7D2E002D9; C++
      //	Convolution method for responses. Input model component,
      //	output folded model component.
      //
      //	For the time being implement output as RealArray.
      //	There might be a better implementation that involved
      //	adding a folded array data member to the Component
      //	class. In the meantime the idea is to output the
      //	RealArray folded component and sum for the total
      //	model.
      //
      //	This must be modified to throw a YellowAlert Exception
      //	for invalid computations and to throw standard numeric
      //	exceptions.
      virtual void operator * (SumComponent& source) const;

    // Additional Public Declarations
      //## begin DummyResponse%3641DA6E0109.public preserve=yes
      //## end DummyResponse%3641DA6E0109.public

  protected:

    //## Other Operations (specified)
      //## Operation: generateResponse%3ED4D2070311
      virtual void generateResponse ();

    // Additional Protected Declarations
      //## begin DummyResponse%3641DA6E0109.protected preserve=yes
      //virtual void setArrays(size_t row) { }

      //virtual void setDescription (size_t spectrumNumber, 
      //	size_t dataGroupNumber, size_t row)  {}
      //## end DummyResponse%3641DA6E0109.protected
  private:
    //## Constructors (generated)
      DummyResponse();

    //## Constructors (specified)
      //## Operation: DummyResponse%37FD0E98F4C0; C++
      //	Constructor for DummyResponse.
      //	      //	The DummyResponse is a singleton class accessed
      //	The DummyResponse is a singleton class accessed
      //	only by a pointer.
      //	      //	The values passed to it will be read from the
      //	The values passed to it will be read from the
      //	initialization
      //	file when this is set up, and that will define its energy
      //	array and whether it is logarithmic or linear.
      //	      //	If the initialization file does not contain a
      //	string
      //	If the initialization file does not contain a string
      //	then default values will be used.
      //	      //	Otherwise, accessor functions will set the size
      //	of the
      //	Otherwise, accessor functions will set the size of the
      //	bins and the energy arrays etc.
      //	      //	The use of dummy response is twofold:
      //	The use of dummy response is twofold:
      //	      //	a) as an energy array for plotting models
      //	a) as an energy array for plotting models
      //	      //	b) as a square channel/energy matrix for showing
      //	b) as a square channel/energy matrix for showing
      //	raw data.
      //	      //	The first use will be given a default value in
      //	the
      //	The first use will be given a default value in the
      //	constructor.
      DummyResponse (Real eMin, Real eMax, size_t nE, bool ln);


    //## Other Operations (specified)
      //## Operation: clone%3AAEA59401B4
      virtual DummyResponse* clone () const;

      //## Operation: source%3AAF86230150
      virtual void source (SpectralData* value);

      //## Operation: source%3AC2299D03B4
      virtual SpectralData* source () const;

    // Additional Private Declarations
      //## begin DummyResponse%3641DA6E0109.private preserve=yes
      //## end DummyResponse%3641DA6E0109.private

  private: //## implementation
    // Data Members for Class Attributes

      //## Attribute: instance%37FB7D2E59C0
      //## begin DummyResponse::instance%37FB7D2E59C0.attr preserve=no  private: static DummyResponse* {U} 0
      static DummyResponse* s_instance;
      //## end DummyResponse::instance%37FB7D2E59C0.attr

    // Additional Implementation Declarations
      //## begin DummyResponse%3641DA6E0109.implementation preserve=yes
      //## end DummyResponse%3641DA6E0109.implementation

};

//## begin DummyResponse%3641DA6E0109.postscript preserve=yes
//## end DummyResponse%3641DA6E0109.postscript

// Class DummyResponse 


//## Other Operations (inline)
inline DummyResponse* DummyResponse::clone () const
{
  //## begin DummyResponse::clone%3AAEA59401B4.body preserve=yes
  //## end DummyResponse::clone%3AAEA59401B4.body

  return const_cast<DummyResponse*>(this);
}

//## begin module%37FDFEB188E0.epilog preserve=yes
//## end module%37FDFEB188E0.epilog


#endif
